#!/usr/bin/env python
# -*- coding: utf-8 -*-

from cxnet.netlink.rtnl import *

from command import command
from cxutil import flags,cmask
from cxutil.utils import opts
from cxutil.exceptions import Dump


class rtnl_handler(rtnl_socket):
	"""
	Netlink signal provider
	"""
	signal = None
	parser = None

	def __init__(self,signal):
		self.signal = signal
		self.parser = rtnl_msg_parser()

		rtnl_socket.__init__(self, groups = RTNLGRP_IPV4_IFADDR | RTNLGRP_LINK)

	def handle(self):
		(l,msg) = self.recv()
		sig = self.parser.parse(msg)
		self.signal(("netlink","netlink.%s.%s" % (sig["type"],sig["action"])), sig)



class netlink (command):
	"""
	Netlink monitoring
	"""
	mask = flags.Esoteric

	def init(self,opts):
		if not opts.call_mask & cmask.Immediate:
			self.s = rtnl_handler(opts.signal)
			opts.esoteric.bus.put("monitor",("register",self.s.fd,self.s.handle))

	def postUp(self,opts):
		pass
